EDIT - feature request #6693

Implement missing nomenclatural codes for name detail element

06/06/2017 11:38 AM - Patrick Plitzner

Status: Closed Start date:
Priority: Highest Due date:
Assignee: Katja Luther % Done: 100%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.10
Severity: major
Description
in class eu.etaxonomy.taxeditor.ui.section.name.NameDetailElement
private void createSpecificNameParts (ICdmFormElement formElement,
INonViralName nonViralName, int style) {
NomenclaturalCode code = nonViralName.getNomenclaturalCode () ;
if (code != null) {
switch (nonViralName.getNomenclaturalCode ()) {
case ICNAFP
//nothing do add
createBotanicalNameParts (formElement, nonViralName, style);

break;
case Fungi
if (isAdvancedView) {

createFungusNameParts (formElement, nonViralName,

}
break;
case ICZN:

createZoologicalNameParts (formElement, nonViralName,

break;

case ICVCN:
//TODO implement
logger.warn ("ICVCN not yet implemented");
break;

case ICNB:
//TODO implement
logger.warn ("ICNB not yet implemented");
break;

case ICNCP:
//TODO implement
logger.warn ("ICNCP not yet implemented");
break;

case NonViral:
//TODO implement
logger.warn ("NonViral not yet implemented");
break;

}

style);

style);

Related issues:

Related to EDIT - feature request #6692: Make name types changeable

Related to EDIT - feature request #6957: Implement cache strategy for viral n...
Related to EDIT - feature request #6963: Implement cache strategy for cultiva...
Related to EDIT - feature request #6361: [MASTER] Merge all TaxonName classes...
Is duplicate of EDIT - feature request #6691: Implement all name types in Nam...
Copied to EDIT - feature request #6950: Alllow the usage of Viral Names

Closed
Closed

In Progress
Closed
Duplicate
New

Associated revisions

Revision 80c710e0 - 09/18/2017 11:48 AM - Katja Luther
ref #6693: add the missing nomenclatural codes for name details view

Revision d903b1d8 - 09/18/2017 08:55 PM - Katja Luther

fix #6693: remove virus nomenclatural code from enumComboElement

Revision 93216326 - 09/21/2017 09:54 PM - Katja Luther

move appended phrase above nom. code specific parts in details

Revision 2b01f647 - 09/22/2017 09:52 AM - Katja Luther

move name approbiation behind Isid in name details view

Revision 27522e15 - 09/22/2017 12:06 PM - Katja Luther

ref #6693: fix update of details view for changed nameType

Revision 8e22f635 - 09/25/2017 09:15 AM - Katja Luther
ref #6693: add subGenusAuthor to null check when changing NC

Revision 202ba579 - 09/25/2017 01:42 PM - Katja Luther

fix #6693: anamorphic must not be true for all other than fungi

History

#1 - 06/06/2017 11:40 AM - Patrick Plitzner
- Related to feature request #6692: Make name types changeable added

#3 - 09/18/2017 11:55 AM - Katja Luther
- Status changed from New to Resolved
- Priority changed from New to Highest

- Target version changed from Unassigned CDM tickets to Release 4.10

added the missing nomenclatural codes, removed the viral code because it causes a NPE. Create a new ticket for details view for viral names (#6950

)

#4 - 09/18/2017 01:18 PM - Andreas Miiller
- Copied to feature request #6950: Alllow the usage of Viral Names added

#5 - 09/18/2017 01:41 PM - Andreas Miuller

Katja Luther wrote:

removed the viral code because it causes a NPE

Can you please commit this, otherwise | can't test

#6 - 09/18/2017 01:51 PM - Katja Luther

is already commited in Revision 80c710e0, see above

#7 - 09/18/2017 03:03 PM - Andreas Miuller

Katja Luther wrote:

is already commited in Revision 80c710e0, see above

But this version still allows choosing ICVCN (however | currently work on the CacheStrategy update, maybe this is sufficient)

#8 - 09/18/2017 03:05 PM - Katja Luther

sorry, | missed to commit it on friday, it was committed three hours ago.

#9 - 09/18/2017 03:27 PM - Andreas Miiller
- File picture96-1.png added
https://dev.e-taxonomy.eu/redmine/issues/6950

Katja Luther wrote:

sorry, | missed to commit it on friday, it was committed three hours ago.

But ICVCN is STILL available in the very latest version build 20 min ago! See attachement.

Please test with nightly.

#10 - 09/18/2017 08:59 PM - Katja Luther
- % Done changed from 0 to 50

Applied in changeset taxeditor|d903b1d88feb526e0d13d330569c5¢7c7ded40d4.

#11 - 09/19/2017 12:51 PM - Andreas Miiller

- Blocked by feature request #6957: Implement cache strategy for viral names added

#12 - 09/20/2017 05:56 PM - Andreas Miiller

- Blocked by deleted (feature request #6957: Implement cache strategy for viral names)

#13 - 09/20/2017 05:56 PM - Andreas Miiller

- Related to feature request #6957: Implement cache strategy for viral names added

#14 - 09/20/2017 06:26 PM - Andreas Miiller

Is it possible to move the "Name approbation” for bacterial names either up below "LSID" or if this is not possible down below "Appended Phrase" as
it is not part of the name but more an explanation.

#15 - 09/20/2017 06:33 PM - Andreas Miiller

Andreas Muller wrote:

Is it possible to move the "Name approbation” for bacterial names either up below "LSID" or if this is not possible down below "Appended
Phrase" as it is not part of the name but more an explanation.

Once this is implemented we can close this ticket from my side. We still need better cache strategies for the "new" codes but this is not part of this
ticket.

#16 - 09/20/2017 06:36 PM - Andreas Miiller

- Related to feature request #6963: Implement cache strategy for cultivar plant names (done), bacterial names, fungi, etc. added

#17 - 09/21/2017 12:25 PM - Andreas Miiller
- Related to feature request #6361: [MASTER] Merge all TaxonName classes into 1 class added

#18 - 09/21/2017 12:31 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Patrick Plitzner to Katja Luther

- Severity changed from normal to major

One more issue, which is a bit critical: we currently do have a hard validation if a name contains only data which is according to its code. E.g. a
ICNAFP name must not have "acronym" or "nameApprobation" set. Otherwise one gets an validation exception and the name is not saved.

Therefore we need to delete these fields once the name type is changed. However, this is a bit critical if one changes the type only accidentally and
changes it back afterwards. This will lead to a loss of data, maybe even not recognized by the user.

Therefore the better solution might be to run this check immediately before saving.

Another solution could be to remove this hard validation, but this may lead to dirty data. Also not nice.

#19 - 09/21/2017 10:21 PM - Katja Luther

- Is duplicate of feature request #6691: Implement all name types in NameDetailElement added

#20 - 09/22/2017 10:02 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/d903b1d88feb526e0d13d330569c5c7c7ded40d4

Andreas Muller wrote:

One more issue, which is a bit critical: we currently do have a hard validation if a name contains only data which is according to its code. E.g. a
ICNAFP name must not have "acronym" or "nameApprobation" set. Otherwise one gets an validation exception and the name is not saved.

Therefore we need to delete these fields once the name type is changed. However, this is a bit critical if one changes the type only accidentally
and changes it back afterwards. This will lead to a loss of data, maybe even not recognized by the user.

Therefore the better solution might be to run this check immediately before saving.

Another solution could be to remove this hard validation, but this may lead to dirty data. Also not nice.

But if you change the type accidentally, you are not able to save the taxon, so you have to delete the name approbiation before you are able to
change the type and loose the data.

#21 - 09/22/2017 01:38 PM - Katja Luther
Andreas Muller wrote:

One more issue, which is a bit critical: we currently do have a hard validation if a name contains only data which is according to its code. E.g. a
ICNAFP name must not have "acronym" or "nameApprobation" set. Otherwise one gets an validation exception and the name is not saved.

Therefore we need to delete these fields once the name type is changed. However, this is a bit critical if one changes the type only accidentally
and changes it back afterwards. This will lead to a loss of data, maybe even not recognized by the user.
Therefore the better solution might be to run this check immediately before saving.

Another solution could be to remove this hard validation, but this may lead to dirty data. Also not nice.

Now a dialog pops up to confirm the deletion of the nametype specific parts.

#22 - 09/22/2017 01:38 PM - Katja Luther

- Status changed from Feedback to Resolved

#23 - 09/22/2017 03:59 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Mtiller to Katja Luther

It seems to be available only for "Name Approbation". But it should be available for all attributes which are not available in the new code.

#24 - 09/25/2017 09:17 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

Andreas Muller wrote:

It seems to be available only for "Name Approbation”. But it should be available for all attributes which are not available in the new code.

subGenusAuthor was missing. For the other codes all attributes are checked.

#25 - 09/25/2017 01:35 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

It is still missing for "anamorphic" when changing from "Fungi" to e.g. ICNAFP. Anamorphic must not be true for any other code then Fungi.

#26 - 09/25/2017 01:40 PM - Andreas Miiller

All the rest seems to work as expected.

#27 - 09/25/2017 01:42 PM - Katja Luther

- Status changed from Feedback to Resolved

Applied in changeset taxeditor|202ba579336a7c3798e2acb9ffcfcb694ef69fcb.
#28 - 09/25/2017 01:42 PM - Katja Luther

- Status changed from Resolved to Feedback

Andreas Muller wrote:

It is still missing for "anamorphic" when changing from "Fungi" to e.g. ICNAFP. Anamorphic must not be true for any other code then Fungi.

| implemented it the oher way round. is fixed

#29 - 09/25/2017 10:19 PM - Andreas Miiller
- Status changed from Feedback to Closed
- % Done changed from 50 to 100

This is now fully fixed
